From 9b3409b9dc25b7ccac17cc3fc1736905382d1ebc Mon Sep 17 00:00:00 2001
From: Daniel Mierswa <impulze@impulze.org>
Date: Sat, 30 Jan 2010 18:43:35 +0100
Subject: [PATCH 03/10] Put system handling into separate file.

Also reoorder system specific stuff a bit.

Signed-off-by: Daniel Mierswa <impulze@impulze.org>
---
 configure.ac     |  149 +++++++++++++++++++++---------------------------------
 m4/vlc_system.m4 |   29 +++++++++++
 2 files changed, 87 insertions(+), 91 deletions(-)
 create mode 100644 m4/vlc_system.m4

diff --git a/configure.ac b/configure.ac
index 94753d0..909122d 100644
--- a/configure.ac
+++ b/configure.ac
@@ -155,39 +155,34 @@ LDFLAGS_vlc="${LDFLAGS}"
 
 dnl
 dnl  Check the operating system
+dnl  Disable features that we're going to default enable based
+dnl  on the operating system.
 dnl
-case "${host_os}" in
-  "")
-    SYS=unknown
-    ;;
-  linux*)
-    SYS=linux
-    ;;
-  bsdi*)
-    SYS=bsdi
+VLC_CHECK_SYS()
+VLC_FEATURE_DEFAULT_DISABLE([peflags])
+AS_CASE(["${SYS}"], 
+  [bsdi], [
     CFLAGS_save="${CFLAGS_save} -pthread"; CFLAGS="${CFLAGS_save}"
     VLC_ADD_LIBS([dvd dvdcss vcd cdda vcdx],[-ldvd])
-    ;;
-  *bsd*)
-    SYS="${host_os}"
+  ],
+  [bsd], [
     CFLAGS_save="${CFLAGS_save} -pthread"; CFLAGS="${CFLAGS_save}"
-    case "${host_os}" in
-      freebsd*)
+    AS_CASE(["${host_os}"],
+      [freebsd*], [
         CPPFLAGS_save="${CPPFLAGS_save} -I/usr/local/include"
         CPPFLAGS="${CPPFLAGS_save}"
         LDFLAGS_save="${LDFLAGS_save} -L/usr/local/lib"
         LDFLAGS="${LDFLAGS_save}"
-        ;;
-      openbsd*)
+      ],
+      [openbsd*], [
         CPPFLAGS_save="${CPPFLAGS_save} -I/usr/local/include -I/usr/X11R6/include"
         CPPFLAGS="${CPPFLAGS_save}"
         LDFLAGS_save="${LDFLAGS_save} -L/usr/local/lib -L/usr/X11R6/lib/"
         LDFLAGS="${LDFLAGS_save}"
-        ;;
-    esac
-    ;;
-  darwin*)
-    SYS=darwin
+      ]
+    )
+  ],
+  [darwin], [
     CFLAGS_save="${CFLAGS_save} -D_INTL_REDIRECT_MACROS"; CFLAGS="${CFLAGS_save}"
     CXXFLAGS_save="${CXXFLAGS_save} -D_INTL_REDIRECT_MACROS"; CXXFLAGS="${CXXFLAGS_save}"
     OBJCFLAGS_save="${OBJCFLAGS_save} -D_INTL_REDIRECT_MACROS -std=gnu99"; OBJCFLAGS="${OBJCFLAGS_save}"
@@ -246,8 +241,8 @@ case "${host_os}" in
         MACOSX_DEPLOYMENT_TARGET=${vlc_string_macosx_version_min}
         export MACOSX_DEPLOYMENT_TARGET
     ])
-    ;;
-  darwin9*)
+  ],
+  [darwin9*], [
     if test "${host_cpu}" = "i386"; then
         dnl Due to a ld(64) bug in 10.5 we cannot use our mmx code
         dnl without hacking it a lot, we disable mmx and sse.
@@ -266,69 +261,28 @@ case "${host_os}" in
             VLC_FEATURE_FORCE_DISABLE([sse], [due to a bug in ld])
         fi
     fi
-    ;;
-  *mingw32* | *cygwin* | *wince* | *mingwce*)
-    AC_CHECK_TOOL(WINDRES, windres, :)
-    AC_CHECK_TOOL(OBJCOPY, objcopy, :)
-
-    case "${host_os}" in
-      *wince* | *mingwce* | *mingw32ce*)
-        SYS=mingwce
-        dnl Sadly CeGCC still needs non-wince macros
-        AC_DEFINE([_WIN32_WINNT], 0x0501, [Define to '0x0500' for Windows 2000 APIs.])
-        ;;
-      *mingw32*)
-        SYS=mingw32
-        AC_DEFINE([_WIN32_WINNT], 0x0500, [Define to '0x0500' for Windows 2000 APIs.])
-        ;;
-      *cygwin*)
-        dnl Check if we are using the mno-cygwin mode in which case we are
-        dnl actually dealing with a mingw32 compiler.
-        AC_DEFINE([_WIN32_WINNT], 0x0500, [Define to '0x0500' for Windows 2000 APIs.])
-        AC_EGREP_CPP(yes,
-            [#ifdef WIN32
-             yes
-             #endif],
-            SYS=mingw32, AC_MSG_ERROR([VLC requires -mno-cygwin]))
-        ;;
-    esac
+  ],
+  [mingwce], [
+    dnl Sadly CeGCC still needs non-wince macros
+    AC_DEFINE([_WIN32_WINNT], 0x0501, [Define to '0x0500' for Windows 2000 APIs.])
 
-    if test "${SYS}" = "mingw32"; then
-        # add ws2_32 for closesocket, select, recv
-        VLC_ADD_LIBS([libvlccore],[-lws2_32 -lnetapi32 -lwinmm])
-        VLC_ADD_LDFLAGS([vlc],[-mwindows])
-        VLC_ADD_LIBS([activex mozilla],[-lgdi32])
-        VLC_ADD_LIBS([cdda vcdx sdl_image aout_sdl vout_sdl],[-lwinmm])
-        VLC_ADD_LIBS([access_http access_mms access_udp access_tcp access_ftp access_rtmp access_output_udp access_output_shout access_output_rtmp sap slp oldhttp stream_out_standard stream_out_rtp stream_out_raop vod_rtsp access_realrtsp rtp oldtelnet oldrc netsync gnutls growl_udp flac ts audioscrobbler lua remoteosd zvbi audiobargraph_a],[-lws2_32])
-        VLC_ADD_LIBS([filesystem], [-lshlwapi])
-        dnl
-        dnl DEP and ASLR options
-        dnl
-        VLC_FEATURE_DEFAULT_ENABLE([peflags])
-        VLC_FEATURE_OPTION([peflags], [peflags use], [enabled on Windows])
-        AS_IF([VLC_FEATURE_ENABLED([peflags])], [
-          AC_CHECK_TOOL(PEFLAGS, peflags, :)
-        ])
-    else
-      VLC_FEATURE_DEFAULT_DISABLE([peflags])
-    fi
-    if test "${SYS}" = "mingwce"; then
-        # add ws2 for closesocket, select, recv
-        VLC_ADD_LIBS([libvlccore access_http access_mms access_udp access_tcp access_ftp access_rtmp access_output_udp access_output_rtmp sap oldhttp netsync audioscrobbler growl rtp stream_out_rtp remoteosd ts oldtelnet audiobargraph_a],[-lws2])
-        VLC_ADD_LIBS([libvlccore],[-lmmtimer])
-   fi
-    ;;
-  *nto*)
-    SYS=nto
-    ;;
-  solaris*)
-    SYS=solaris
-    ;;
-  hpux*)
-    SYS=hpux
-    ;;
-  beos)
-    SYS=beos
+    # add ws2 for closesocket, select, recv
+    VLC_ADD_LIBS([libvlccore access_http access_mms access_udp access_tcp access_ftp access_rtmp access_output_udp access_output_rtmp sap oldhttp netsync audioscrobbler growl rtp stream_out_rtp remoteosd ts oldtelnet audiobargraph_a],[-lws2])
+    VLC_ADD_LIBS([libvlccore],[-lmmtimer])
+  ],
+  [mingw32], [
+    AC_DEFINE([_WIN32_WINNT], 0x0500, [Define to '0x0500' for Windows 2000 APIs.])
+
+    # add ws2_32 for closesocket, select, recv
+    VLC_ADD_LIBS([libvlccore],[-lws2_32 -lnetapi32 -lwinmm])
+    VLC_ADD_LDFLAGS([vlc],[-mwindows])
+    VLC_ADD_LIBS([activex mozilla],[-lgdi32])
+    VLC_ADD_LIBS([cdda vcdx sdl_image aout_sdl vout_sdl],[-lwinmm])
+    VLC_ADD_LIBS([access_http access_mms access_udp access_tcp access_ftp access_rtmp access_output_udp access_output_shout access_output_rtmp sap slp oldhttp stream_out_standard stream_out_rtp stream_out_raop vod_rtsp access_realrtsp rtp oldtelnet oldrc netsync gnutls growl_udp flac ts audioscrobbler lua remoteosd zvbi audiobargraph_a],[-lws2_32])
+    VLC_ADD_LIBS([filesystem], [-lshlwapi])
+    VLC_FEATURE_DEFAULT_ENABLE([peflags])
+  ],
+  [beos], [
     CFLAGS_save="${CFLAGS_save} -Wno-multichar"; CFLAGS="${CFLAGS_save}"
     CXXFLAGS_save="${CXXFLAGS_save} -Wno-multichar"; CXXFLAGS="${CXXFLAGS_save}"
     VLC_ADD_CXXFLAGS([beos],[])
@@ -342,11 +296,9 @@ case "${host_os}" in
     else
         VLC_ADD_LIBS([filesystem access_ftp access_mms access_output_udp oldtelnet netsync sap libvlccore growl_udp],[-lnet])
     fi
-    ;;
-  *)
-    SYS="${host_os}"
-    ;;
-esac
+  ]
+)
+
 AM_CONDITIONAL(HAVE_BEOS, test "${SYS}" = "beos")
 AM_CONDITIONAL(HAVE_DARWIN, test "${SYS}" = "darwin")
 AM_CONDITIONAL(HAVE_LINUX, [test "${SYS}" = "linux"])
@@ -856,6 +808,14 @@ AC_ARG_VAR(PKG_CONFIG_PATH,
 	   [Paths where to find .pc not at the default location])
 PKG_PROG_PKG_CONFIG()
 
+dnl windres and objcopy for windows
+AS_CASE(["${SYS}"],
+  [mingw*], [
+    AC_CHECK_TOOL(WINDRES, windres, :)
+    AC_CHECK_TOOL(OBJCOPY, objcopy, :)
+  ]
+)
+
 dnl On some OS we need static linking 
        AS_IF([test -n "${PKG_CONFIG}" ],[
 	      AS_IF([test "${SYS}" = "mingw32" -o "${SYS}" = "mingwce" -o "${SYS}" = "darwin" ],[
@@ -889,6 +849,13 @@ then
 fi
 AM_CONDITIONAL(HAVE_MINIZIP, [ test "${have_minizip}" = "yes" ])
 
+dnl
+dnl DEP and ASLR options
+dnl
+VLC_FEATURE_OPTION([peflags], [peflags use], [enabled on Windows])
+AS_IF([VLC_FEATURE_ENABLED([peflags])], [
+  AC_CHECK_TOOL(PEFLAGS, peflags, :)
+])
 
 dnl Check for dbus
 AS_CASE(
diff --git a/m4/vlc_system.m4 b/m4/vlc_system.m4
new file mode 100644
index 0000000..7b99a0c
--- /dev/null
+++ b/m4/vlc_system.m4
@@ -0,0 +1,29 @@
+dnl Handling system specific things.
+
+AC_DEFUN([VLC_CHECK_SYS], [
+  AS_CASE(["${host_os}"],
+    [""], [SYS="unknown"],
+    [linux*], [SYS="linux"],
+    [bsdi*], [SYS="bsdi"],
+    [*bsd*], [SYS="bsd"],
+    [darwin*], [SYS="darwin"],
+    [*wince* | *mingwce* | *mingw32ce*], [SYS="mingwce"],
+    [*mingw32*], [SYS="mingw32"],
+    [*cygwin*], [
+      dnl Check if we are using the mno-cygwin mode in which case we are
+      dnl actually dealing with a mingw32 compiler.
+      AC_EGREP_CPP([yes],
+        [#ifdef WIN32
+         yes
+         #endif],
+        [SYS=mingw32],
+        [AC_MSG_ERROR([VLC requires -mno-cygwin])]
+      )
+    ],
+    [*nto*], [SYS="nto"],
+    [solaris*], [SYS="solaris"],
+    [hpux*], [SYS="hpux"],
+    [beos], [SYS="beos"],
+    [SYS="${host_os}"]
+  )
+])
-- 
1.6.6.1


